Attribute VB_Name = "ModFunctions"
Option Explicit

' //////////////////////////////////////////////////////////////////
' ////////////////// getting the filename/path from path\filename //
' //////////////////////////////////////////////////////////////////
Public Function GetFileNameFromFull(istring As String) As String
Dim start, n As Long
For n = 1 To Len(istring)
    If Mid$(istring, n, 1) = "\" Then
        start = n
    End If
Next
GetFileNameFromFull = Right(istring, Len(istring) - start)
End Function

Public Function GetFilePathFromFull(istring As String) As String
On Error Resume Next
Dim start, n As Long
For n = 1 To Len(istring)
    If Mid$(istring, n, 1) = "\" Then
        start = n
    End If
Next
GetFilePathFromFull = Left(istring, start - 1)
End Function

' //////////////////////////////////////////////////////////////////
' ////////////////// Fileexists                                   //
' //////////////////////////////////////////////////////////////////

Public Function FileExists(sFileName As String) As Integer
    If Len(sFileName) = 0 Then
        FileExists = False
        Exit Function
    End If

    If Len(Dir$(sFileName)) Then
        FileExists = True
    Else
        FileExists = False
    End If
End Function

' /////////////////////////////////////////////////////////
' ////////////////// COMMENT DATABASE ACCESSING ///////////
' /////////////////////////////////////////////////////////


Function Getcomment(ifile As String) As String
On Error GoTo iend

If Not FileExists(commentdatabase) Then
    MakeNewCommentList
End If

Open commentdatabase For Input As #1
Dim file, Comment As String

Do Until EOF(1)
  Input #1, file
  Input #1, Comment
        If file = ifile Then
            GoTo OK
        End If
Loop
GoTo iend

OK:
Getcomment = Comment

iend:
Close #1

End Function

Function SetComment(ifile As String, icomment As String)
Dim fileupdated As Boolean
Dim file, Comment As String  ' used for reading

If Not FileExists(commentdatabase) Then ' If the commentdatabase doesn't exist, make a new one
    MakeNewCommentList
End If

Open App.Path & "\comments.$$$" For Output As #2    ' OPEN THE FILES
Open commentdatabase For Input As #1                       '      "  "


Do
            Input #1, file     ' READ FROM OLD FILE
            Input #1, Comment  '       " "
            
            Print #2, file     ' WRITE NAME
            
            If file = ifile Then   ' IF INNAME MATCHES TOCHANGE Then
                Print #2, icomment ' PRINT NEW COMMENT
                fileupdated = True ' SAY "I already updated the file"
            Else
                Print #2, Comment  ' ELSE PRINT OLD COMMENT
            End If
            
Loop Until EOF(1)

If fileupdated = False Then ' IF I DIDN'T SAY "I already updated the file"
        Print #2, ifile     ' WRITE NAME
        Print #2, icomment  ' AND COMMENT
End If

Close #1, #2                ' close files

ReplaceCommentFiles                ' replace old with the one i just made

End Function

Function DELComment(ifile As String)
Dim fileupdated As Boolean
Dim file, Comment As String  ' used for reading
On Error GoTo iend

If Not FileExists(commentdatabase) Then ' If the commentdatabase doesn't exist, exit
    MakeNewCommentList
End If
If Len(commentdatabase) = 0 Then
    Kill commentdatabase
    MakeNewCommentList
End If
Open App.Path & "\comments.$$$" For Output As #2    ' OPEN THE FILES
Open commentdatabase For Input As #1                       '      "  "


Do
            Input #1, file     ' READ FROM OLD FILE
            Input #1, Comment  '       " "
            
            If file = ifile Then
                ' SKIP THE WRITE ROUTINE
            Else
                Print #2, file     ' WRITE NAME
                Print #2, Comment  ' WRITE COMMENT
            End If
            
Loop Until EOF(1)
iend:
Close #1, #2                ' close files
ReplaceCommentFiles                ' replace old with the one i just made
End Function

Public Sub changecomment(ifile As String)
' this sub asks the user to input a new comment for ifile
Dim inew As String
inew = InputBox("New comment for " & ifile, , Getcomment(ifile))
SetComment ifile, inew
End Sub
Sub MakeNewCommentList()
Open commentdatabase For Output As #1
        Print #1, App.Path & "\readme.txt"
        Print #1, App.Title & " Readme File"
Close #1
End Sub

Sub ReplaceCommentFiles()
On Error GoTo err
Kill commentdatabase                                   ' DELETE commentdatabase
FileCopy App.Path & "\comments.$$$", commentdatabase   ' COPY TEMP TO commentdatabase
Kill App.Path & "\comments.$$$"                 ' DELETE TEMP
Exit Sub
err:
MsgBox "Error " & err.Number & " occured while working with comment database", vbCritical
End Sub

Function databasemess() As Single

Open commentdatabase For Input As #1
Dim file, Comment As String
Dim countgood, countbad, countblank As Single

Do Until EOF(1)
  Input #1, file
  Input #1, Comment
    
    If Comment = "" Then
        countblank = countblank + 1
    Else
        If FileExists(LCase(file)) Then
            countgood = countgood + 1
        Else
            countbad = countbad + 1
        End If
    End If
Loop
Close #1
databasemess = countblank + countbad
End Function

Function databasecount() As Single
On Error Resume Next
Open commentdatabase For Input As #1
Dim file, Comment As String

Do Until EOF(1)
  Input #1, file
  Input #1, Comment
  databasecount = databasecount + 1
Loop
Close #1

End Function

Public Function ReplaceS(istring As String, iold As String, inew As String) As String
On Error GoTo err
Dim start, n As Long
For n = 1 To Len(istring)
    If Mid$(istring, n, Len(iold)) = iold Then
        start = n
    End If
Next
ReplaceS = Left(istring, start - 1) & inew & Right(istring, Len(istring) - (start + Len(iold) - 1))
Exit Function
err:
ReplaceS = istring
End Function


